<?php

namespace NoccyLabs\MessageCatalog;

use PHPUnit\Framework\Attributes\CoversClass;

#[CoversClass(Message::class)]
class MessageTest extends \PHPUnit\Framework\TestCase
{

    public function testCreatingMessageAndGettingAll()
    {
        $message = new Message(a:'aa', b:'bb', c:'cc');
        $this->assertEquals(['a'=>'aa', 'b'=>'bb', 'c'=>'cc'], $message->getAllContent());
    }

    public function testCreatingMessageAndGettingOne()
    {
        $message = new Message(a:'aa', b:'bb', c:'cc');
        $this->assertEquals('aa', $message->getContent('a'));
        $this->assertEquals('bb', $message->getContent('b'));
        $this->assertEquals('cc', $message->getContent('c'));
    }

    public function testTransformingMessages()
    {
        $message = new Message(text:"Hello %{who}");
        $transformed = $message->getTransformed([ 'who' => 'World' ]);
        $this->assertEquals("Hello World", $transformed['text']);
    }
}
